import './symbol';
import { TypedArray, TypedArrayConstructor, DynamicTypedArrayOptions } from './types';
export default class DynamicTypedArray<T extends TypedArray> {
    private _array;
    private _length;
    private _constructor;
    private _growthPolicy;
    private _allocator;
    private _deallocator;
    private _reallocator;
    constructor(constructor?: TypedArrayConstructor<T>, init?: number | ArrayLike<number> | Iterable<number>, {growthPolicy, allocator, deallocator, reallocator}?: DynamicTypedArrayOptions);
    size(): number;
    capacity(): number;
    get(index: number): number;
    set(index: number, value: number): void;
    push(...values: number[]): void;
    pop(): number;
    forEach(callback: (value: number, index: number) => void, thisArg?: any): void;
    [Symbol.iterator](): Iterator<number>;
    toArray(): number[];
    toJSON(): number[];
    toString(): string;
    private _ensureCapacity(minCapacity);
    private _resize(capacity);
}
